#ifndef BIHTree_H_
#define BIHTree_H_

struct BIHNode
{	
	bool isLeaf;
	union {
		struct Leaf
		{
			unsigned int item;
			unsigned int count;
		} leaf;
		struct Inner
		{
			unsigned char axis;
			BIHNode* childs[2];
			float boundaries[2];	
		} inner;
	};
	BIHNode(unsigned int item, unsigned int count);
	BIHNode(unsigned char axis);
	~BIHNode();
};

#define AXIS(index) index & 3
#define INDEX(index) index >> 2
#define ISLEAF(index) (index & 3) == 3

struct BIHNode2
{

	unsigned int index;
	union {
		struct Leaf
		{
			unsigned int count;
		} leaf;
		struct Inner
		{
			float boundaries[2];	
		} inner;
	} data;
	BIHNode2();
	BIHNode2(const BIHNode2& node);
	BIHNode2(unsigned int startIndex, unsigned int count);
	BIHNode2(unsigned char axis, unsigned int childrenIndex, float boundaries[2]);
	~BIHNode2();
};

class BIHTree
{
	public:
		BIHNode* root;
		const Vector min;
		const Vector max;
		BIHTree(const Vector& min, const Vector& max);
		~BIHTree();
};

class BIHTree2
{
	public:
		const BIHNode2* root;
		const Vector min;
		const Vector max;
		const int depth;
		const int count;
		BIHTree2(const BIHNode2* root, const Vector& min, const Vector& max, const int depth, const int count);
		~BIHTree2();
};

#endif