//=====================================================================================================================
//
// Unnamed Realtime Ray Tracer - Copyright by Jyrki Friedrich. All rights reserved.
// You are free to use Unnamed Realtime Ray Tracer for non-commercial purposes.
// for all other projects: mail t4rj4n@gmail.com
//
//=====================================================================================================================

#ifndef BIHRANDTREEBUILDER_H_
#define BIHRANDTREEBUILDER_H_

#include <queue>
#include <math.h>
#include <assert.h>
#include <float.h>

#include "Types.h"
#include "Helpers.h"

class BIHRandTreeBuilder
{
	private:
		static void BIHExchange(VertexTriangle* triangles, int a, int b);
		static void BIHNormalExchange(NormalTriangle* triangles, int a, int b);
		static bool LeftSmaller(VertexTriangle* triangles, int i, int axis, float pivotValue, float& currentMaxValue);
		static bool RightGreaterOrEqual(VertexTriangle* triangles, int j, int axis, float pivotValue, float& currentMinValue);
		static int BIHPartition(VertexTriangle* triangles, NormalTriangle* normals, int left, int right, float pivotValue, int axis, float& maxValue, float& minValue);
		static void BIHBuildTree(BIHNode* & node, VertexTriangle* triangles, NormalTriangle* normals, int start, int end, Vector min, Vector max);
		static void BIHSort(VertexTriangle* triangles, NormalTriangle* normals, int left, int right, int axis, float& maxValue, float& minValue);

	public:
		// build the tree
		static BIHTree* Compile(Scene * scene);
};

#endif /* BIHRANDTREEBUILDER_H_ */