//=====================================================================================================================
//
// Unnamed Realtime Ray Tracer - Copyright by Jyrki Friedrich. All rights reserved.
// You are free to use Unnamed Realtime Ray Tracer for non-commercial purposes.
// for all other projects: mail t4rj4n@gmail.com
//
//=====================================================================================================================

#ifndef HELPERS_H_
#define HELPERS_H_

#include "Types.h"

class Helpers
{
	public:
		// load the scene
		static void LoadSceneFromFile(Scene* scene, char* fileName);
		// build accelerated structures from triangles
		static TriAccel* BuildTriAccels(VertexTriangle* triangles, NormalTriangle* normals, int count);
		static bool CheckBoundingBox(VertexTriangle* triangles, int start, int end, Vector min, Vector max);
		// returns the axis for which the bounding box has greatest width
		static unsigned int LongestAxis(float length[3]);
		// calculates the bounding box for an array of points
		static void GetBoundingBox(Vector* points, int count, Vector& min, Vector& max);
		// count all leave items
		static int CountItems(const BIHNode * node);
		// count nodes
		static int CountNodes(BIHNode* node);
		// calculates depth
		static int GetDepth(BIHNode* node);
		// count all leave items
		static int CountItems(const BIHNode2* node);
		// converts old node structure to new one
		static BIHNode2* BIHTransformTree(BIHNode* root);

};

#endif /* HELPERS_H_ */
