//=====================================================================================================================
//
// Unnamed Realtime Ray Tracer - Copyright by Jyrki Friedrich. All rights reserved.
// You are free to use Unnamed Realtime Ray Tracer for non-commercial purposes.
// for all other projects: mail t4rj4n@gmail.com
//
//=====================================================================================================================

#include <stdio.h>
#include <stdlib.h>

#include "math.h"
#include "assert.h"

#include "Sampler.h"

Vector Sampler::GetRandomHemiSpherePoint(Vector surfaceNormal)
{
	Vector up(0,1,0);
	Vector p(2.0f*rand()/RAND_MAX-1,1.0f*rand()/RAND_MAX+BIAS,2.0f*rand()/RAND_MAX-1);
	while (p.length() > 1)
	{
		p = Vector(2.0f*rand()/RAND_MAX-1,1.0f*rand()/RAND_MAX+BIAS,2.0f*rand()/RAND_MAX-1);
	}
	p = p.normalize();
	float dot = surfaceNormal*up;
	if (dot == 1.0f)
	{
		return p;
	}
	else if (dot == -1.0f)
	{
		return -p;
	}
	else
	{
		Vector cross = surfaceNormal.cross(up).normalize();
		float angle = acos(dot);
		Matrix m = Matrix::rotation(cross, angle);
		Vector r = m*p;
		float check = r*surfaceNormal;
		//assert(check+BIAS >= 0);
		return r;
	}
}
